# MPI_Get_address

Get the address of a location in memory

## Synopsis

    int MPI_Get_address(const void *location, MPI_Aint * address)

## Input Parameters

location
  location in caller memory (choice)

## Output Parameters

address
  address of location (address integer)

## Notes

This routine is provided for both the Fortran and C programmers. On many systems, the address returned by this routine will be the same as produced by the C `&` operator, but this is not required in C and may not be true of systems with word- rather than byte-oriented instructions or systems with segmented address spaces.

This routine should be used instead of `MPI_Address`.

## Thread and Interrupt Safety

This routine is both thread- and interrupt-safe. This means that this routine may safely be used by multiple threads and from within a signal handler.

## Notes for Fortran

All MPI routines in Fortran (except for `MPI_WTIME` and `MPI_WTICK`) have an additional argument `ierr` at the end of the argument list. `ierr` is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the `call` statement.

All MPI objects (e.g., `MPI_Datatype`, `MPI_Comm`) are of type `INTEGER` in Fortran.

In Fortran, the integer type is always signed. This can cause problems on systems where the address fits into a four byte unsigned integer but the value is larger than the largest signed integer. For example, a system with more than 2 GBytes of memory may have addresses that do not fit within a four byte signed integer. Unfortunately, there is no easy solution to this problem, as there is no Fortran datatype that can be used here (using a longer integer type will cause other problems, as well as surprising users when the size of the integer type is larger that the size of a pointer in C). In this case, it is recommended that you use C to manipulate addresses.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Comm_set_errhandler` (for communicators), `MPI_File_set_errhandler` (for files), and `MPI_Win_set_errhandler` (for RMA windows). The MPI-1 routine `MPI_Errhandler_set` may be used but its use is deprecated. The predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarantee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
  No error; MPI routine completed successfully.

MPI_ERR_OTHER
  Other error; use `MPI_Error_string` to get more information about this error code.